unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TMyThread }

  TMyThread = class(TThread)
  private
    FLblMsg,
    FBtnMsg: Integer;
    procedure SendMsg2Label;
    procedure SendMsg2Button;
  protected
    procedure Execute; override;
  public
    constructor Create(CreateSuspended: Boolean);
  end;
  { TFrmMain }

  TFrmMain = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
  private

  public

  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.lfm}

{ TFrmMain }

procedure TFrmMain.Button1Click(Sender: TObject);
var
  MyThr: TMyThread;
begin
  try
    MyThr:= TMyThread.Create(True);

    while not MyThr.Finished do
    begin
      Application.ProcessMessages;
      Sleep(50);
    end;
  finally
    FreeAndNil(MyThr);
  end;
end;

{ TMyThread }

procedure TMyThread.SendMsg2Label;
begin
  FrmMain.Label1.Caption:= Format('Текущее значение счетчика: %d',[FLblMsg]);
end;

procedure TMyThread.SendMsg2Button;
begin
  FrmMain.Button1.Caption:= IntToStr(FBtnMsg);
end;

procedure TMyThread.Execute;
const
  k: Integer = 100;
var
  i: Integer;
begin
  for i:= 0 to k do
  begin
    FLblMsg:= i;//присвоим текущее значение счетчика
    Queue(@SendMsg2Label);//аналог PostMessage


    FBtnMsg:= k - i;//присвоим оставшееся значение счетчика
    Synchronize(@SendMsg2Button);//аналог SendMessage
    Sleep(50);
  end;
end;

constructor TMyThread.Create(CreateSuspended: Boolean);
begin
  inherited Create(CreateSuspended);
  Priority:= tpLowest;
  FreeOnTerminate:= False;

  if CreateSuspended then Start;
end;

end.

